/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * cvmparameters.h
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * cvm_cpp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cvm_cpp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _CVMPARAMETERS_H_
#define _CVMPARAMETERS_H_

class cvm_parameters
{
public:
	cvm_parameters(void);
	void SetIterations(unsigned int iNumberOfIterations);          // worst case iteration threshold
	void SetC(double dC);										   // C = 1 should work often
	void SetEpsilon(double dEpsilon);							   // dEpsilon = 0.01 is in general a save choice
	double GetC(void);
	double GetEpsilon(void);
	unsigned int GetIterations(void);
	int GetSparsity(void);
	void SetSparsity(int iSparsity);
protected:
	
private:
	unsigned int m_iNumberOfIterations; 
	double m_dC;
	double m_dEpsilon;
	int m_iSparsity;
};

#endif // _CVMPARAMETERS_H_

