/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * cvmtrain.h
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * This is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * The code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _CVMTRAIN_H_
#define _CVMTRAIN_H_
#include <armadillo>
#include "cvmparameters.h"
#include "cvmmodel.h"
#include "kernel-matrix_interface.h"
#include "cvmtrain_interface.h"
using namespace std;
using namespace arma;

class cvm_train: public ICVMTrainInterface
{
public:
	cvm_train();
	~cvm_train();
	void Apply(const IKernelMatrixInterface& oKernel, const vec &Label);
	cvm_parameters GetParameters(void);
	void SetParameters(cvm_parameters oParameters);
	cvm_model GetModel(void);
protected:

private:
	int CoreSetSolver(const IKernelMatrixInterface &oKernel,const vec &Label, const colvec &vDiagsK, double epsilon,  colvec &vDeltas, ucolvec &S, double &R, colvec &vAlpha);
	//int CoreSetSolver(const mat &K, double epsilon,const colvec &vDiags, colvec &vDeltas, ucolvec &S, double &R, colvec &vAlpha); 
	cvm_parameters m_oParameters;
	cvm_model m_oCVMModel;
};

#endif // _CVMTRAIN_H_

