/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * pcvmtrain_interface.h
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * This is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * The code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _CVMTRAIN_INTERFACE_H_
#define _CVMTRAIN_INTERFACE_H_
#include <armadillo>
#include "cvmparameters.h"
#include "cvmmodel.h"
#include "kernel-matrix_interface.h"
using namespace std;
using namespace arma;

class ICVMTrainInterface
{
public:	
	virtual ~ICVMTrainInterface() {};
	virtual void Apply(const IKernelMatrixInterface& oKernel, const vec &Label) = 0;
	virtual cvm_parameters GetParameters(void) = 0;
	virtual void SetParameters(cvm_parameters oParameters) = 0;
	virtual cvm_model GetModel(void) = 0;
};

#endif // _CVMTRAIN_INTERFACE_H_

