/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * multiclassmodel_Factory.cc
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * pcvm_cpp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * pcvm_cpp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
// the serialization templates (used somewhere later) need to be known here
// to generate the right code by boost and ! to avoid that the e.g. main code
// needs to know all implementation details
#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>
//#include "pcvm_serialization.hpp"
#include "cvmmulticlassmodel.h"
#include "cvmmulticlassmodel_each.h"
#include "math_stat_helper.hpp"
#include "multiclassmodel_factory.h"
#include <vector>
#include <boost/bind.hpp>
#include "cvm_serialization.hpp"

using namespace std;


MultiClassModelFactory::MultiClassModelFactory(multimodeltype eType)
{
	switch(eType)
	{
		case one_vs_all:
			std::cout << "ova" <<std::endl;
			multiclassmodel = boost::shared_ptr<IMultiClassModelInterface>(new cvm_multiclass_model());
			break;
		case each_vs_each:
			std::cout << "eae" <<std::endl;
			multiclassmodel = boost::shared_ptr<IMultiClassModelInterface>(new cvm_multiclass_model_each());
			break;
	}
}

