/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * cvmparameters.cc
 * Copyright (C) 2015 Frank-Michael Schleif <schleify@cs.bham.ac.uk>
 *
 * cvm_cpp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cvm_cpp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cvmparameters.h"
cvm_parameters::cvm_parameters(void)
{
	m_iNumberOfIterations = 500;
	m_dEpsilon = 0.01;
	m_dC = 1;
	m_iSparsity = 0;
}

void cvm_parameters::SetIterations(unsigned int iNumberOfIterations)
{
	m_iNumberOfIterations = iNumberOfIterations;
}

void cvm_parameters::SetSparsity(int iSparsity)
{
	m_iSparsity = iSparsity;
}

void cvm_parameters::SetC(double dC)
{
	m_dC = dC;
}

void cvm_parameters::SetEpsilon(double dEpsilon)
{
	m_dEpsilon = dEpsilon;
}

double cvm_parameters::GetC(void)
{
	return m_dC;
}

double cvm_parameters::GetEpsilon(void)
{
	return m_dEpsilon;
}

unsigned int cvm_parameters::GetIterations(void)
{
	return m_iNumberOfIterations;
}

int cvm_parameters::GetSparsity(void)
{
	return m_iSparsity;
}






